import org.junit.Assert;
import org.junit.Test;

import static org.junit.Assert.*;

public class MyArrayListTest {


    @Test
    public void testAddInteger() {
        Integer[] inputArray = new Integer[]{1, 2, 3,  4, 5, 6, 7, 8};

        Integer add = 9;
        Integer [] expected = new Integer[]{1, 2, 3,  4, 5, 6, 7, 8, add};

        MyArrayList myArrayList = new MyArrayList(inputArray);
        Object [] actual =  myArrayList.add(add);


        assertArrayEquals(expected, actual);
    }

    @Test
    public void testAddString() {
        String[] inputArray = new String[]{"James Talbot", "2 Phones Jones", "Jimmy BeepBop", "Mike Lawwrryyy"};

        String add  = "Calabassas Jones";
        String [] expected = new String[]{"James Talbot", "2 Phones Jones", "Jimmy BeepBop", "Mike Lawwrryyy",  add};

        MyArrayList myArrayList = new MyArrayList(inputArray);
        Object [] actual =  myArrayList.add(add);


        assertArrayEquals(expected, actual);
    }

    @Test
    public void testAddObject() {
        Object[] inputArray = new Object[]{"we used", 2, "fuss", "wh", 4, "n the landlord", "diss", 3, "d us"};

        Object add = "NO HEAT";
        Object [] expected = new Object[]{"we used", 2, "fuss", "wh", 4, "n the landlord", "diss", 3, "d us", add};

        MyArrayList myArrayList = new MyArrayList(inputArray);
        Object [] actual =  myArrayList.add(add);


        assertArrayEquals(expected, actual);
    }

    @Test
    public void testGetSpecifiedInteger(){
        Integer expected = 45;
        Integer[] inputArray = new Integer[] {45, 9, 19, expected, 85, 34, 6};

        MyArrayList myArrayList = new MyArrayList(inputArray);
        Object actual = myArrayList.get(expected);

        assertEquals(expected, actual);
    }

    @Test
    public void testGetSpecifiedString(){
        String expected = "Calabassas Jones";
        String[] inputArray = new String[] {"James Talbot", "2 Phones Jones", "Jimmy BeepBop", expected, "Mike Lawwrryyy"};

        MyArrayList myArrayList = new MyArrayList(inputArray);
        Object actual = myArrayList.get(expected);

        assertEquals(expected, actual);
    }

    @Test
    public void testGetSpecifiedObject(){
        Object expected = 65;
        Object[] inputArray = new Object[] {"$8,247.00", 34, "2 Phones Jones", expected, "Mike Lawwrryyy"};

        MyArrayList myArrayList = new MyArrayList(inputArray);
        Object actual = myArrayList.get(expected);

        assertEquals(expected, actual);
    }


    @Test
    public void testRemoveIntegerAtIndex(){
        Integer[] inputArray = new Integer[]{1, 2, 3, 4, 5, 6, 7, 8};
        Integer index = 5;

        Integer[] expected = new Integer[]{1, 2,  3, 4, 5, 7, 8};
        MyArrayList myArrayList = new MyArrayList(inputArray);

        Object[] actual = myArrayList.remove(index);

        assertArrayEquals(expected, actual);
    }

    @Test
    public void testRemoveStringAtIndex(){
        String[] inputArray = new String[]{"waka", "flocka", "Pikachu", "Bushmaster", "Shabba", "Tom Hanks in Big"};
        Integer index = 3;

        String[] expected = new String[]{"waka", "flocka", "Pikachu", "Shabba", "Tom Hanks in Big"};


        MyArrayList myArrayList = new MyArrayList(inputArray);
        Object[] actual = myArrayList.remove(index);

        assertArrayEquals(expected, actual);
    }

    @Test
    public void testRemoveSpecifiedInteger(){
        Integer numberToRemove = 4;

        Integer[] inputArray = new Integer[]{1, numberToRemove, 3, numberToRemove, 5, 6, 7, 8};
        Integer[] expected  = new Integer[]{1, 3, 5, 6, 7, 8};

        MyArrayList myArrayList = new MyArrayList(inputArray);
        Object[] actual = myArrayList.remove1(numberToRemove);

        assertArrayEquals(expected, actual);
    }

    @Test
    public void testRemoveSpecifiedString(){
        String stringToRemove = "bong bong";

        String[] inputArray = new String[]{"waka", stringToRemove, "flocka", stringToRemove, "Pikachu", "Bushmaster", "Shabba", "Tom Hanks in Big"};
        String[] expected = new String[]{"waka", "flocka", "Pikachu", "Bushmaster", "Shabba", "Tom Hanks in Big"};


        MyArrayList myArrayList = new MyArrayList(inputArray);
        Object[] actual = myArrayList.remove1(stringToRemove);

        assertArrayEquals(expected, actual);
    }


    @Test
    public void testSetInteger(){
        Integer index = 5;
        Integer replace = 646;

        Integer[] inputArray = new Integer[]{1, 2, 3,  4, 5, 6, 7, 8};
        Integer[] expected = new Integer[] {1, 2, 3, 4, 5, replace, 7, 8};

        MyArrayList myArrayList = new MyArrayList(inputArray);
        Object[] actual = myArrayList.set(index, replace);

        assertArrayEquals(expected, actual);
    }

    @Test
    public void testSetString(){
        Integer index = 2;
        String replace = "Brooklyn Baby Bombada";

        String[] inputArray = new String[]{"James Talbot", "2 Phones Jones", "Jimmy BeepBop", "Mike Lawwrryyy"};
        String[] expected = new String[]{"James Talbot", "2 Phones Jones", replace, "Mike Lawwrryyy"};

        MyArrayList myArrayList = new MyArrayList(inputArray);
        Object[] actual = myArrayList.set(index, replace);

        assertArrayEquals(expected, actual);
    }

    @Test
    public void testSetObject(){
        Integer index = 4;
        Object replace = "Brooklyn Baby Bombada";

        Object[] inputArray = new Object[]{'c', "2 Phones Jones", 669, "Aquemini",  "Jimmy BeepBop", "Mike Lawwrryyy"};
        Object[] expected = new Object[]{ 'c' , "2 Phones Jones", 669, "Aquemini", replace, "Mike Lawwrryyy"};

        MyArrayList myArrayList = new MyArrayList(inputArray);
        Object[] actual = myArrayList.set(index, replace);

        assertArrayEquals(expected, actual);
    }

    @Test
    public void testClearIntegerArray(){
        Integer[] inputArray = new Integer[]{1, 2, 3,  4, 5, 6, 7, 8};

        Integer[] expected = new Integer[0];

        MyArrayList myArrayList = new MyArrayList(inputArray);
        Object[] actual = myArrayList.clear();

        assertArrayEquals(expected, actual);
    }

    @Test
    public void testClearStringArray(){
        String[] inputArray = new String[]{"James Talbot", "2 Phones Jones", "Jimmy BeepBop", "Mike Lawwrryyy"};

        String[] expected = new String[0];

        MyArrayList myArrayList = new MyArrayList(inputArray);
        Object[] actual = myArrayList.clear();

        assertArrayEquals(expected, actual);

    }

    @Test
    public void testIsEmptyInteger(){
        Integer[] inputArray = new Integer[]{1, 2, 3,  4, 5, 6, 7, 8};
        Integer[] input2 = new Integer[0];

        MyArrayList myArrayList = new MyArrayList(inputArray);
        MyArrayList myArrayList2 = new MyArrayList(input2);


        assertFalse(myArrayList.isEmpty());
        assertTrue(myArrayList2.isEmpty());
    }

    @Test
    public void testIsEmptyString(){
        String[] inputArray = new String[]{"James Talbot", "2 Phones Jones", "Jimmy BeepBop", "Mike Lawwrryyy"};
        String[] input2 = new String[0];

        MyArrayList myArrayList = new MyArrayList(inputArray);
        MyArrayList myArrayList2 = new MyArrayList(input2);


        assertFalse(myArrayList.isEmpty());
        assertTrue(myArrayList2.isEmpty());
    }

    @Test
    public void testContainsInteger(){
        Integer value = 7;

        Integer[] inputArray = new Integer[]{1, 2, 3, 4, 5, 6, 8};
        Integer[] input2 = new Integer[]{1, 2, value, 4, 5, 6, value, 8};

        MyArrayList myArrayList = new MyArrayList(inputArray);
        MyArrayList myArrayList2 = new MyArrayList(input2);


        assertFalse(myArrayList.contains(value));
        assertTrue(myArrayList2.contains(value));
    }

    @Test
    public void testContainsString(){
        String value = "Tone Loc";

        String[] inputArray = new String[]{"James Talbot", "2 Phones Jones", "Jimmy BeepBop", "Mike Lawwrryyy"};
        String[] inputArray2 = new String[]{"James Talbot", value, "2 Phones Jones", "Jimmy BeepBop", value, "Mike Lawwrryyy"};

        MyArrayList myArrayList = new MyArrayList(inputArray);
        MyArrayList myArrayList2 = new MyArrayList(inputArray2);


        assertFalse(myArrayList.contains(value));
        assertTrue(myArrayList2.contains(value));
    }
}