import org.junit.Assert;
import org.junit.Test;

import static org.junit.Assert.*;

public class MySetTest {

    @Test
    public void testAddInteger() {
        Integer add = 89;

        Integer[] inputArray = new Integer[]{1, 2, 3, 4, 5, 6, 7, 8};
        Integer[] expected = new Integer[]{1, 2, 3, 4, 5, 6, 7, 8, add};

        MySet mySet = new MySet(inputArray);
        Object[] actual = mySet.add(add);


        assertArrayEquals(expected, actual);
    }

    @Test
    public void testAddString() {
        String[] inputArray = new String[]{"James Talbot", "2 Phones Jones", "Jimmy BeepBop", "Mike Lawwrryyy"};

        String add = "Calabassas Jones";
        String[] expected = new String[]{"James Talbot", "2 Phones Jones", "Jimmy BeepBop", "Mike Lawwrryyy", add};

        MySet mySet = new MySet(inputArray);
        Object[] actual = mySet.add(add);


        assertArrayEquals(expected, actual);
    }

    @Test
    public void testAddAllInteger() {
        Integer[] inputArray = new Integer[]{1, 2, 3, 4, 5, 6, 7, 8};
        Integer[] newArray = new Integer[inputArray.length];
        Integer[] expected = new Integer[]{1, 2, 3, 4, 5, 6, 7, 8};

        MySet mySet = new MySet(inputArray);
        Object[] actual = mySet.addAll(newArray);


        assertArrayEquals(expected, actual);
    }

    @Test
    public void testAddAllString() {
        String[] inputArray = new String[]{"James Talbot", "2 Phones Jones", "Jimmy BeepBop", "Mike Lawwrryyy"};
        String[] newArray = new String[inputArray.length];
        String[] expected = new String[]{"James Talbot", "2 Phones Jones", "Jimmy BeepBop", "Mike Lawwrryyy"};

        MySet mySet = new MySet(inputArray);
        Object[] actual = mySet.addAll(newArray);


        assertArrayEquals(expected, actual);
    }

    @Test
    public void testClearInteger() {
        Integer[] inputArray = new Integer[]{1, 2, 3, 4, 5, 6, 7, 8};

        Integer[] expected = new Integer[0];

        MySet mySet = new MySet(inputArray);
        Object[] actual = mySet.clear();

        assertArrayEquals(expected, actual);
        //removes all elements from set
    }

    @Test
    public void testClearString() {
        String[] inputArray = new String[]{"James Talbot", "2 Phones Jones", "Jimmy BeepBop", "Mike Lawwrryyy"};

        String[] expected = new String[0];

        MySet mySet = new MySet(inputArray);
        Object[] actual = mySet.clear();

        assertArrayEquals(expected, actual);
    }


    @Test
    public void testContainsInteger() {
        Integer value = 7;

        Integer[] inputArray = new Integer[]{1, 2, 3, 4, 5, 6, 8};
        Integer[] inputArray2 = new Integer[]{1, 2, value, 4, 5, 6, value, 8};

        MySet mySet = new MySet(inputArray);
        MySet mySet1 = new MySet(inputArray2);


        assertFalse(mySet.contains(value));
        assertTrue(mySet1.contains(value));
    }
    @Test
    public void testContainsString() {
        String value = "Jimmy BeepBop";

        String[]inputArray = new String[]{"James Talbot", "2 Phones Jones", "Mike Lawwrryyy"};
        String[]inputArray2 = new String[]{"waka", "flocka", "Pikachu", value, "Shabba", "Tom Hanks in Big"};

        MySet mySet = new MySet(inputArray);
        MySet mySet1 = new MySet(inputArray2);

        assertFalse(mySet.contains(value));
        assertTrue(mySet1.contains(value));
    }

    @Test
    public void testContainsAllInt() {
        Integer[] inputArray = new Integer[]{1, 2, 3, 4, 5, 6, 8};

        Integer[] inputArray2 = new Integer[]{1, 2, 3, 4, 5, 6, 8};
        Integer[] inputArray3 = new Integer[]{1, 2, 3, 6, 5, 6, 8};

        MySet mySet = new MySet(inputArray);

        assertTrue(mySet.containsAll(inputArray2));
        assertFalse(mySet.containsAll(inputArray3));

    }
//    @Test
//    public void testContainsAllString() {
//        String[] inputArray = new String[]{"James Talbot", "2 Phones Jones", "Jimmy BeepBop", "Mike Lawwrryyy"};
//
//        String[] inputArray2 = new String[]{"James Talbot", "2 Phones Jones", "Jimmy BeepBop", "Mike Lawwrryyy"};
//        String[] inputArray3 = new String[]{"Makiavelli", "2 Phones Jones", "Jimmy BeepBop", "Mike Lawwrryyy"};
//
//        MySet mySet = new MySet(inputArray);
//
//
//        assertTrue(mySet.containsAll(inputArray2));
//        assertFalse(mySet.containsAll(inputArray3));
//    }

    @Test
    public void testEqualsArrLengthInt() {
        Integer[] inputArray = new Integer[8];
        Integer[] inputArray2 = new Integer[8];
        Integer[] inputArray3 = new Integer[4];

        MySet mySet = new MySet();

        assertTrue(mySet.equals(inputArray, inputArray2));
        assertFalse(mySet.equals(inputArray, inputArray3));
        assertFalse(mySet.equals(inputArray2, inputArray3));
    }
    @Test
    public void testEqualsArrLengthString() {
        String[] inputArray = new String[8];
        String[] inputArray2 = new String[8];
        String[] inputArray3 = new String[4];

        MySet mySet = new MySet();

        assertTrue(mySet.equals(inputArray, inputArray2));
        assertFalse(mySet.equals(inputArray, inputArray3));
        assertFalse(mySet.equals(inputArray2, inputArray3));
    }

    @Test
    public void testHashCodeInt() {
        Integer[] inputArray = new Integer[]{1, 5, 3, 4, 5, 6, 8};

        Integer expected = inputArray.hashCode();

        MySet mySet = new MySet(inputArray);
        Integer actual = mySet.getHash(inputArray);

        assertEquals(expected, actual);
    }
    @Test
    public void testHashCodeString() {
        String[]inputArray = new String[]{"James Talbot", "2 Phones Jones", "Mike Lawwrryyy"};

        Integer expected = inputArray.hashCode();

        MySet mySet = new MySet(inputArray);
        Integer actual = mySet.getHash(inputArray);

        assertEquals(expected, actual);
    }

    @Test
    public void testIsEmptyInteger() {
        Integer[] inputArray = new Integer[]{1, 2, 3, 4, 5, 6, 7, 8};
        Integer[] inputArray2 = new Integer[0];

        MySet mySet = new MySet(inputArray);
        MySet mySet2 = new MySet(inputArray2);


        assertFalse(mySet.isEmpty());
        assertTrue(mySet2.isEmpty());
    }
    @Test
    public void testIsEmptyString() {
        String[] inputArray = new String[]{"James Talbot", "2 Phones Jones", "Jimmy BeepBop", "Mike Lawwrryyy"};
        String[] inputArray2 = new String[0];

        MySet mySet = new MySet(inputArray);
        MySet mySet2 = new MySet(inputArray2);


        assertFalse(mySet.isEmpty());
        assertTrue(mySet2.isEmpty());
    }

    @Test
    public void testRemoveInteger() {
        Integer numberToRemove = 4;

        Integer[] inputArray = new Integer[]{1, numberToRemove, 3, numberToRemove, 5, 6, 7, 8};
        Integer[] expected = new Integer[]{1, 3, 5, 6, 7, 8};

        MySet mySet = new MySet(inputArray);
        Object[] actual = mySet.remove(numberToRemove);

        assertArrayEquals(expected, actual);
    }
    @Test
    public void testRemoveString() {
        String stringToRemove = "bong bong";

        String[] inputArray = new String[]{"waka", stringToRemove, "flocka", stringToRemove, "Pikachu", "Bushmaster", "Shabba", "Tom Hanks in Big"};
        String[] expected = new String[]{"waka", "flocka", "Pikachu", "Bushmaster", "Shabba", "Tom Hanks in Big"};


        MySet mySet = new MySet(inputArray);
        Object[] actual = mySet.remove(stringToRemove);

        assertArrayEquals(expected, actual);

    }
    @Test
    public void testRemoveAllInt() {
        Integer[] inputArray = new Integer[]{1, 2, 3, 4, 5, 6, 7, 8};

        Integer[] expected = new Integer[0];

        MySet mySet = new MySet(inputArray);
        Object[] actual = mySet.removeAll();

        assertArrayEquals(expected, actual);
    }
    @Test
    public void testRemoveAllString() {
        String[] inputArray  = new String[]{"waka", "flocka", "Pikachu", "Bushmaster", "Shabba", "Tom Hanks in Big"};

        String[] expected = new String[0];

        MySet mySet = new MySet(inputArray);
        Object[] actual = mySet.removeAll();

        assertArrayEquals(expected, actual);
    }

    @Test
    public void testRetainAllInteger() {
        Integer[] array = new Integer[]{4, 5, 6};
        Integer[] inputArray = new Integer[]{1, 2, 3, 4, 5, 6, 7, 8};

        Integer[] expected = new Integer[]{4, 5, 6};

        MySet mySet = new MySet(array);

        assertTrue(mySet.retainAll(inputArray));
    }
    @Test
    public void testRetainAllString() {
        String[] array = new String[]{"shut em down", "open up shop", "whoah"};
        String[] inputArray = new String[]{"stop", "drop", "shut em down", "open up shop", "whoah", "nooo"};

        String[] expected = new String[]{"shut em down", "open up shop", "whoah"};
        MySet mySet = new MySet(array);

        assertTrue(mySet.retainAll(inputArray));
    }

    @Test
    public void testSizeInt() {
        Integer[] inputArray = new Integer[]{1, 2, 3, 4, 5, 6, 7, 8};
        Integer expected = inputArray.length;

        MySet mySet = new MySet(inputArray);
        Integer actual = mySet.size();

        assertEquals(expected, actual);
    }
    @Test
    public void testSizeString() {
        String[] inputArray = new String[]{"stop", "drop", "shut em down", "open up shop", "whoah", "nooo"};
        Integer expected = inputArray.length;

        MySet mySet = new MySet(inputArray);
        Integer actual = mySet.size();

        assertEquals(expected, actual);
    }

    @Test
    public void testToArrayInt() {
        Integer bigAssInteger = 546931957;

        String[] expected = new String[]{"5", "4", "6", "9", "3", "1", "9", "5", "7"};
        MySet mySet = new MySet(bigAssInteger);
        String[] actual = mySet.toArray();

        assertArrayEquals(expected, actual);
    }
    @Test
    public void testToArrayString() {
        String bigAssString = "I ain't a killer but don't push me. Revenge is but the sweetest joy next to getting..";

        String[] expected = bigAssString.split("");
        MySet mySet = new MySet(bigAssString);
        String[] actual = mySet.toArray();

        assertArrayEquals(expected, actual);
    }

}
